--Explosive Speed (XSpeed) - Boost to Win! At a Price...
--built off of hpmod by Callmore
--original hpmod code is mostly used to track who is alive/dead, also reused low hp warning sprites to indicate when someone is going to explode


--yes there are 13 different versions of the countdown
freeslot("SPR_HPWN", "S_HPWARNING1", "S_HPWARNING2", "MT_HPWARNING", "sfx_hpelmn")
freeslot("sfx_cdn0")
freeslot("sfx_cdn1")
freeslot("sfx_cdn2")
freeslot("sfx_cdn3")
freeslot("sfx_cdn4")
freeslot("sfx_cdn5")
freeslot("sfx_cdn6")
freeslot("sfx_cdn7")
freeslot("sfx_cdn8")
freeslot("sfx_cdn9")
freeslot("sfx_cdn10")
freeslot("sfx_cdn11")
freeslot("sfx_cdn12")

freeslot("sfx_surv")
freeslot("sfx_race")

states[S_HPWARNING1] = {SPR_HPWN, FF_FULLBRIGHT|A, 8, nil, 0, 0, S_HPWARNING2}
states[S_HPWARNING2] = {SPR_HPWN, FF_FULLBRIGHT|B, 8, nil, 0, 0, S_HPWARNING1}

mobjinfo[MT_HPWARNING] = {
	spawnstate = S_HPWARNING1,
	spawnhealth = 1000,
	radius = FRACUNIT,
	height = FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_DONTENCOREMAP
}

local XSnDead = 0
local XSmaxTrackLength = 0
local XStopLap = 0

local starttime = 6*TICRATE + (3*TICRATE/4)
local XSeveryoneDeadTimer = 0
local XSexitTimer = 0

local XSdeadPlayers = {}

local XSretirestr = "ELIMINATED"
local XSretirelen = nil

local XSisSprintTrack = false
local XSsprintTrackTime = 0
local XSlobbySizeTime = 0
local dtWindow = 20
--local XSrejoinsOK = true

addHook("NetVars", function(net) --not sure all of these need to sync up, but to be safe
	XSnDead = net($)
	XSmaxTrackLength = net($)
	XSisSprintTrack = net($)
	XSsprintTrackTime = net($)
	XSlobbySizeTime = net($)
	XStopLap = net($)
	--original hpmod vars
	XSpeed = net($)
	XSeveryoneDeadTimer = net($)
	XSexitTimer = net($)
	XSdeadPlayers = net($)
end)

local cv_XSmode = CV_RegisterVar{
	name = "XSpeed_mode",
	defaultvalue = "Boost",
	flags = CV_NETVAR,
	PossibleValue = {boost=0, orbi=1, both=2}
}

local cv_XSinputs = CV_RegisterVar{
	name = "XSpeed_defaultInputs",
	defaultvalue = "Double",
	flags = CV_NETVAR,
	PossibleValue = {Double=0, Customs=1}
}

local cv_enabled = CV_RegisterVar{
	name = "XSpeed_enabled",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}

local cv_moretime = CV_RegisterVar{
	name = "XSpeed_moretime",
	defaultvalue = 0,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 0, MAX = 999}
}

local cv_tutorial = CV_RegisterVar{
	name = "XSpeed_tutorial",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}

rawset(_G, "XSpeed", {
	running = false,
})

local function sfxChange(p, arg)
	-- arg == 0 or arg == 1 or arg = tostring(arg):lower()
	arg = tostring(arg):lower()
	if arg == "on"  then
		p.XSsfx = true
	elseif arg == "off" then 
		p.XSsfx = false
	else 
		CONS_Printf(p, "Invalid option")
		CONS_Printf(p, "options: on / off")
	end 
end
COM_AddCommand("XSpeed_sfx", sfxChange, 0)

local function inputsChange(p, arg)
	-- arg == 0 or arg == 1 or arg = tostring(arg):lower()
	if arg:lower() == "double"
		p.XStutorial.inputs = 0
	elseif arg:lower() == "customs"
		p.XStutorial.inputs = 1
	else
		CONS_Printf(p, "Invalid option")
		CONS_Printf(p, "options: double / customs")
	end
end
COM_AddCommand("XSpeed_inputs", inputsChange, 0)

local function XSspawnnoisemaker(p) --borrowed from hornmod by Tyron
	p.countdown = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
	p.countdown.state = S_INVISIBLE
	p.countdown.tics = -1
	p.countdown.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
end

local function generateHFForPlayer(p)	--hpmod code
	if p and p.valid and p.mo and p.mo.valid then
		return {{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
	else
		return {{}, {}}
	end
end

local function countPlayersInGame() --modified hpmod code
	local out = 0
	XSnDead = 0
	for p in players.iterate do
		if not (p and p.valid and not p.spectator) then continue end
		out = $+1
		if p.XSpeed.deathtimer
			XSnDead = $+1
		end
	end
	return out
end

local function killPlayer(p) --hpmod code
	if not XSpeed.running then return end

	if not (p and p.valid and p.mo) then return end
	p.lives = 0
	p.pflags = $ | PF_TIMEOVER
	p.kartstuff[k_position] = countPlayersInGame()
	--XSnDead = XSnDead + 1
	S_ChangeMusic("KRFAIL", true, p)
	P_DamageMobj(p.mo, nil, nil, 10000)
end

local function pushChangeFeed(p, positive, amount) --only 3 most recent changes are shown on HUD
	local amountString = "Error"
	if not positive then
		amountString = "-" + tostring(amount)
	else
		amountString = "+" + tostring(amount)
	end
	
	if p.XSpeed.changeFeed[1][0] ~= "" then --2 or 3 changes still visible, put new one at top, bump other two down
		p.XSpeed.changeFeed[2][0] = p.XSpeed.changeFeed[1][0]
		p.XSpeed.changeFeed[2][1] = p.XSpeed.changeFeed[1][1]
		p.XSpeed.changeFeed[1][0] = p.XSpeed.changeFeed[0][0]
		p.XSpeed.changeFeed[1][1] = p.XSpeed.changeFeed[0][1]
		p.XSpeed.changeFeed[0][0] = amountString
		p.XSpeed.changeFeed[0][1] = leveltime
	elseif p.XSpeed.changeFeed[0][0] ~= "" then --1 change still visible
		p.XSpeed.changeFeed[1][0] = p.XSpeed.changeFeed[0][0]
		p.XSpeed.changeFeed[1][1] = p.XSpeed.changeFeed[0][1]
		p.XSpeed.changeFeed[0][0] = amountString
		p.XSpeed.changeFeed[0][1] = leveltime
	else --0 changes visible
		p.XSpeed.changeFeed[0][0] = amountString
		p.XSpeed.changeFeed[0][1] = leveltime
	end
end
		
local function addTime(p, time)
	p.XSpeed.timeLeft = p.XSpeed.timeLeft + time
	p.XSpeed.timeJump = true	--used to track when the countdown music should skip
	pushChangeFeed(p, true, time)
end

local function removeTime(p, time)
	p.XSpeed.timeLeft = p.XSpeed.timeLeft - time
	p.XSpeed.timeJump = true	--used to track when the countdown music should skip
	pushChangeFeed(p, false, time)
end

local function stealTime(v, s, time)
	if not(type(s) == "table" or v.exiting or v.nukedone) and
		v ~= s and (s == nil or s.XSpeed.killer == nil or v ~= s.XSpeed.killer) then --don't steal time from yourself
		time = min(time, v.XSpeed.timeLeft)
		removeTime(v, time)
		--v.XSpeed.timeJump = true
		if not s.XSpeed.deathtimer and 	--don't give time to dead players
			s and s.valid and s.XSpeed and 
			(s.XSpeed.finalGambitTimer == 0 or v.XSpeed.timeLeft == 0) then --don't give time to final gambit players, unless it's the actual final gambit
			addTime(s,  time)
			--s.XSpeed.timeJump = true
			if v.XSpeed.timeLeft <= 0 and s.XSpeed.finalGambitTimer <= 0 then
				v.XSpeed.killer = s
				s.kartstuff[k_invincibilitytimer] = 3 * TICRATE -- + $
			end
		end
	end
end

local function resetXSpeed(p, laps)
	p.XSpeed = {
		timeLeft = 100 + XSlobbySizeTime + cv_moretime.value + XSsprintTrackTime, --initial time given at start of race
		ticCount = 0,
		boostCost = laps, --also orbiCost
		nBoosts = 1,	--multiplier for boost use cost, increments each use, resets each lap
		nOrbis = 1,		--multiplier for orbi use cost, increments each use, resets each lap
		timespent = 0,
		itemSelect = 0, --only used in both mode
		
		--buffers for detecting various inputs
		boostBuffer = true,	--also used for orbis since only one can be selected at once
		tutorialBuffer = true,
		swapBuffer = true,
		dtDBuffer = true,
		dtUBuffer = true,
		lastDTime = 0,
		lastUTime = 0,
		
		--countdown stuff
		countDownMusic = false,
		--countDownCoolDown = 0,
		timeJump = false,
		musicOn = true,
		
		finalGambitTimer = 0,
		deathtimer = 0,
		killer = nil,
		--timerBoost = 0,
		
		--stuff for estimating track length
		lastlap = 0,
		lastLapTime = 0,
		lastCheckpoint = 0,
		lastCheckpointx = 0,
		lastCheckpointy = 0,
		trackLength = 0,
		
		--anti-cheat stuff
		itemsUsedCount = 0,
		slowpokeTimer = 0,
		itemBuffer = true,
		
		nukedone = false,	--delete all items when there is a winner so we don't get double kos
		wasSpec = false,
		lastBump = starttime,
		spawnTime = 0,
		changeFeed = {},
		--hp = 10000,
	}
	
	for i=0,3 do
		p.XSpeed.changeFeed[i] = {}
		p.XSpeed.changeFeed[i][0] = ""
		p.XSpeed.changeFeed[i][1] = 0
	end
end

local function shouldHurt(p) --hpmod code
	return not (p.powers[pw_flashing] > 0 or p.kartstuff[k_squishedtimer] > 0 or p.kartstuff[k_spinouttimer] > 0
	or p.kartstuff[k_invincibilitytimer] > 0 or p.kartstuff[k_growshrinktimer] > 0 or p.kartstuff[k_hyudorotimer] > 0 
	or (G_BattleGametype() and ((p.kartstuff[k_bumper] <= 0 and p.kartstuff[k_comebacktimer]) or p.kartstuff[k_comebackmode] == 1)))
end

local function getBumpSpeed(p) --hpmod code
	return FixedMul(p.speed, p.kartweight*(FRACUNIT/16)+FRACUNIT)
end

local function XSpeedChange()	--hpmod code
	for p in players.iterate do
		if not (p and p.valid) then continue end
		resetXSpeed(p, mapheaderinfo[gamemap].numlaps)
	end
	XSeveryoneDeadTimer = 0
	
	XSpeed.running = cv_enabled.value
	if not XSpeed.running then return end

	for i = 0, 15 do
		for p = 0, 3 do
			local obj = P_SpawnMobj(0, 0, 0, MT_HPWARNING)
			obj.eflags = $|MFE_DRAWONLYFORP1<<p
			obj.targetplayern = i
			obj.displayplayern = p
			obj.colorized = true
			obj.color = SKINCOLOR_BLUE
		end
	end
end

local function XSpeedDoBoost(p)
	K_DoSneaker(p, 1)
	if acrobatics	--to trick Acrobatics
		p.tricksneakerbuffer = p.kartstuff[k_sneakertimer]+1
	end
	removeTime(p, p.XSpeed.boostCost * p.XSpeed.nBoosts)
	p.XSpeed.timespent = $ + p.XSpeed.boostCost * p.XSpeed.nBoosts
	p.XSpeed.nBoosts = $ + 1
end

local function XSpeedFireOrbi(p) --borrowed from R9A Arrowhead by Marsh and Angular
	local orbiSpeed = FixedMul(FixedMul(96*FRACUNIT, FRACUNIT+FRACUNIT/4), mapheaderinfo[gamemap] and mapheaderinfo[gamemap].mobj_scale or FRACUNIT)
	local orbi = P_SpawnMobj(p.mo.x + p.mo.momx + FixedMul(orbiSpeed, cos(p.mo.angle)) + P_ReturnThrustX(p.mo, p.frameangle, p.mo.radius + 24*FRACUNIT), 
	p.mo.y + p.mo.momy + FixedMul(orbiSpeed, sin(p.mo.angle))+ P_ReturnThrustY(p.mo, p.frameangle, p.mo.radius + 24*FRACUNIT), 
	p.mo.z, MT_ORBINAUT)
	orbi.angle = p.mo.angle
	orbi.source = p.mo
	orbi.target = p.mo
	
	--If we're moving pretty fast, that's a multiplier.
	if p.speed > K_GetKartSpeed(p, false)
		orbiSpeed = max($, FixedMul($, FixedDiv(p.speed, K_GetKartSpeed(p, false))))
	end
	
	P_TeleportMove(orbi, p.mo.x + p.mo.momx + FixedMul(orbiSpeed, cos(p.mo.angle)), p.mo.y + p.mo.momy + FixedMul(orbiSpeed, sin(p.mo.angle)), P_MobjFlip(p.mo) < 0 and (p.mo.z + p.mo.height - mobjinfo[orbi].height) or p.mo.z)
	
	if (P_IsObjectOnGround(p.mo))
		P_TeleportMove(orbi, orbi.x, orbi.y, orbi.z)
		if (P_MobjFlip(p.mo) < 0)	
			orbi.z = orbi.ceilingz - orbi.height
			orbi.eflags = orbi.eflags & MFE_VERTICALFLIP
		else
			orbi.z = orbi.floorz
		end
	end
	
	orbi.angle = p.mo.angle
	orbi.momx = FixedMul(orbiSpeed, cos(p.mo.angle))
	orbi.momy = FixedMul(orbiSpeed, sin(p.mo.angle))
	orbi.movefactor = orbiSpeed
	K_PlayAttackTaunt(p.mo)
	orbi.color = p.skincolor
	
	removeTime(p, p.XSpeed.boostCost * p.XSpeed.nOrbis)
	p.XSpeed.timespent = $ + p.XSpeed.boostCost * p.XSpeed.nOrbis
	p.XSpeed.nOrbis = $ + 1
end

local function XSpeedSpecialInput(p, inputType)
	if inputType == 1
		if p.XStutorial.inputs == 0	--double tap
			if p.cmd.buttons & BT_FORWARD then
				if p.XSpeed.dtUBuffer then
					p.XSpeed.dtUBuffer = false
					if cv_XSmode.value == 2 and leveltime <= p.XSpeed.lastDTime + dtWindow and leveltime <= p.XSpeed.lastUTime + 2 * dtWindow and p.XSpeed.swapBuffer then
							p.XSpeed.itemSelect = (p.XSpeed.itemSelect + 1) % 2
							p.XSpeed.swapBuffer = false
							p.XSpeed.lastUTime = leveltime
					else
						p.XSpeed.swapBuffer = true
						if leveltime > p.XSpeed.lastUTime + dtWindow then
							p.XSpeed.lastUTime = leveltime
						else
							if (cv_XSmode.value == 0 or (cv_XSmode.value == 2 and p.XSpeed.itemSelect == 0)) and P_IsObjectOnGround(p.mo) and p.XSpeed.timeLeft > p.XSpeed.boostCost * p.XSpeed.nBoosts
								XSpeedDoBoost(p)
								p.XSpeed.lastUTime = 0
							elseif (cv_XSmode.value == 1 or (cv_XSmode.value == 2 and p.XSpeed.itemSelect == 1)) and p.XSpeed.timeLeft > p.XSpeed.boostCost * p.XSpeed.nOrbis and leveltime >= starttime + 10*TICRATE
								XSpeedFireOrbi(p)
								p.XSpeed.lastUTime = 0
							end
						end
					end
				end
			else
				p.XSpeed.dtUBuffer = true
			end
		elseif p.XStutorial.inputs == 1 --customs
			if p.cmd.buttons & BT_CUSTOM1 then 						
				if p.XSpeed.boostBuffer
					if (cv_XSmode.value == 0 or (cv_XSmode.value == 2 and p.XSpeed.itemSelect == 0)) and P_IsObjectOnGround(p.mo) and p.XSpeed.timeLeft > p.XSpeed.boostCost * p.XSpeed.nBoosts
						XSpeedDoBoost(p)
						p.XSpeed.boostBuffer = false
					elseif (cv_XSmode.value == 1 or (cv_XSmode.value == 2 and p.XSpeed.itemSelect == 1)) and p.XSpeed.timeLeft > p.XSpeed.boostCost * p.XSpeed.nOrbis and leveltime >= starttime + 10*TICRATE
						XSpeedFireOrbi(p)
						p.XSpeed.boostBuffer = false
					end
				end
			else
				p.XSpeed.boostBuffer = true
			end
		end
	elseif inputType == 2
		if p.XStutorial.inputs == 0	--double tap
			if p.cmd.buttons & BT_BACKWARD then
				if p.XSpeed.dtDBuffer then
					p.XSpeed.dtDBuffer = false
					if leveltime > p.XSpeed.lastDTime + dtWindow
						p.XSpeed.lastDTime = leveltime
					else
						p.XStutorial.slide = p.XStutorial.slide + 1
						p.XSpeed.lastDTime = 0
					end
				end
			else
				p.XSpeed.dtDBuffer = true
			end
		elseif p.XStutorial.inputs == 1	--customs
			if p.cmd.buttons & BT_CUSTOM3 and cv_tutorial.value then
				p.XStutorial.hold = p.XStutorial.hold + 1
				if p.XStutorial.buffer then
					p.XStutorial.slide = p.XStutorial.slide + 1
					p.XStutorial.buffer = false
				end
				if p.XStutorial.hold > TICRATE
					p.XStutorial.slide = 9
				end
			else
				p.XStutorial.hold = 0
				p.XStutorial.buffer = true
			end
			if p.cmd.buttons & BT_CUSTOM2 and cv_XSmode.value == 2 then
				if p.XSpeed.swapBuffer then
					p.XSpeed.itemSelect = (p.XSpeed.itemSelect + 1) % 2
					p.XSpeed.swapBuffer = false
				end
			else
				p.XSpeed.swapBuffer = true
			end
		end
	end
	
	if leveltime < starttime and p.XStutorial.inputs != 1 and p.cmd.buttons & BT_CUSTOM1 and p.cmd.buttons & BT_CUSTOM2 and p.cmd.buttons & BT_CUSTOM3
		p.XStutorial.inputs = 1
	end
end

local function XSpeedThink()
	--we have to keep checking this
	for p in players.iterate do
		if p.XStutorial == nil then
			p.XStutorial = {
				slide = 0,
				buffer = false,
				hold = 0,
				inputs = cv_XSinputs.value
			}
			p.XSsfx = true
			p.XSprevMode = "none"
			p.XSmodeChange = true
		end
	end
	
	if leveltime == 1 then
		if G_BattleGametype() then
			G_ExitLevel()
			print("Explosive Speed is not compatible with battle. Leaving map.")
		end
		
		if (mapheaderinfo[gamemap].levelflags & LF_SECTIONRACE) then
			XSisSprintTrack = true
			
			--shoutout to splashdown for being stupid long
			local diff = CV_FindVar("kartspeed")
			if diff.value == 1
				XSsprintTrackTime = 60
			elseif diff.value == 2
				XSsprintTrackTime = 50
			elseif diff.value == 0
				XSsprintTrackTime = 70
			end
			
			for p in players.iterate
				if p.XSprevMode ~= "race"
					S_StartSound(nil, sfx_race, p)
					p.XSmodeChange = true
				else
					p.XSmodeChange = false
				end
				p.XSprevMode = "race"
			end
			
		else
			XSisSprintTrack = false
			
			XSsprintTrackTime = 0
			
			COM_BufInsertText(server, "numlaps 50") 
			COM_BufInsertText(server, 'basenumlaps 50')
			
			for p in players.iterate
				if p.XSprevMode ~= "surv"
					S_StartSound(nil, sfx_surv, p)
					p.XSmodeChange = true
				else
					p.XSmodeChange = false
				end
				p.XSprevMode = "surv"
			end
		end
		
		--reset global vars
		XSnDead = 0
		XStopLap = 0
		XSmaxTrackLength = 0
		
		XSpeedChange()
		for p in players.iterate do
			resetXSpeed(p, mapheaderinfo[gamemap].numlaps)
		end
	end
	
	if leveltime == 7 then --idk why this can't be done at leveltime == 1
		--bonus time for small lobbies
		local nplayers = countPlayersInGame()
		if nplayers <= 8 and nplayers >1
			if nplayers <= 4
				if nplayers <= 2
					XSlobbySizeTime = 50
				else
					XSlobbySizeTime = 25
				end
			else
				XSlobbySizeTime = 15
			end
		else
			XSlobbySizeTime = 0
		end
		
		for p in players.iterate do
			resetXSpeed(p, mapheaderinfo[gamemap].numlaps)
		end
	end
	
	if leveltime == starttime then
		--redo this in case people joined/left
		local nplayers = countPlayersInGame()
		if nplayers <= 8 and nplayers > 1
			if nplayers <= 4
				if nplayers <= 2
					XSlobbySizeTime = 50
				else
					XSlobbySizeTime = 25
				end
			else
				XSlobbySizeTime = 15
			end
		else
			XSlobbySizeTime = 0
		end
		
		for p in players.iterate do
			if not (p and p.valid and not p.spectator) then continue end
			resetXSpeed(p, mapheaderinfo[gamemap].numlaps)
			p.XSpeed.lastCheckpointx = p.mo.x
			p.XSpeed.lastCheckpointy = p.mo.y
		end
	end
	
	if leveltime < 1 then return end
	if not XSpeed.running then return end

	--hpmod code
	--first we gotta check if everyone is somehow dead
	if XSeveryoneDeadTimer then --GGS IDIOTS, YOU ALL KILLED EACHOTHER AND NOW NOONE SHALL WIN		
		if XSeveryoneDeadTimer == 1 then
			S_StopMusic()
		elseif XSeveryoneDeadTimer == (TICRATE*1)+(TICRATE/2) then
			S_ChangeMusic("GOVER", false, nil)
		elseif XSeveryoneDeadTimer > (TICRATE*10)+(TICRATE/2) then
			S_ChangeMusic("KRFAIL", true, nil, 0, 3*MUSICRATE)
			G_ExitLevel()
		end
		XSeveryoneDeadTimer = $+1
		return
	end
	
	--check if someone has exited
	do
		local someoneExit = false
		for p in players.iterate do
			if p.exiting then
				someoneExit = true
				XSexitTimer = $+1
				break
			end
		end

		if not someoneExit then
			XSexitTimer = 0
		end
	end

	--main game stuff	
	for p in players.iterate
		if p and p.valid
			if not p.XSpeed then
				resetXSpeed(p, mapheaderinfo[gamemap].numlaps)
			end
			--late joins are penalized to keep things fair
			if p.spectator then 
				p.XSpeed.wasSpec = true 
				continue 
			end
			
			if p.XSpeed.wasSpec
					if leveltime > starttime
						removeTime(p, (((leveltime - starttime) / TICRATE) + 1) - (100 + XSlobbySizeTime + cv_moretime.value + XSsprintTrackTime - p.XSpeed.timeLeft))
					end
					p.XSpeed.spawnTime = leveltime
				p.XSpeed.wasSpec = false
			end
			
			--countdown noisemaker
			if not p.countdown or not p.countdown.valid then
				XSspawnnoisemaker(p)
			end
			P_TeleportMove(p.countdown, p.mo.x, p.mo.y, p.mo.z)
			
			XSpeedSpecialInput(p, 2)
			
			--main game thinking
			if p.exiting then --restore music
				S_StopSound(p.countdown)
				S_SetInternalMusicVolume(100, p)
				
			elseif leveltime > starttime then
				--estimating track length by connecting the dots between checkpoints, there's probably a better way to do this
				if p.starpostnum > p.XSpeed.lastCheckpoint then
					p.XSpeed.trackLength = p.XSpeed.trackLength + P_AproxDistance(p.mo.x - p.XSpeed.lastCheckpointx, p.mo.y - p.XSpeed.lastCheckpointy) / FRACUNIT
					p.XSpeed.lastCheckpointx = p.mo.x
					p.XSpeed.lastCheckpointy = p.mo.y
					p.XSpeed.lastCheckpoint = p.starpostnum
				end
				
				--item spam decay
				if leveltime % (15*TICRATE) == 0 and p.XSpeed.itemsUsedCount > 0 then
					p.XSpeed.itemsUsedCount = p.XSpeed.itemsUsedCount - 1
				end
				
				--item spam tracking if you are not in the same lap as the leader
				if p.laps < XStopLap	
					if p.kartstuff[k_itemroulette] and p.kartstuff[k_roulettetype] != 2 then
						if p.XSpeed.itemBuffer then
							p.XSpeed.itemBuffer = false
							p.XSpeed.itemsUsedCount = p.XSpeed.itemsUsedCount + 1
							if p.XSpeed.itemsUsedCount > 2 + P_RandomFixed() % 3 then --randomize this a bit so it can't be played around, this limit should never be reached if a player is racing normally
								XSdeadPlayers[#XSdeadPlayers+1] = {p, {{"Item Spam", 0}, {"K_HSWALL", 0}}, 1, true}
							end
						end
					else
						p.XSpeed.itemBuffer = true
					end
				end
				
				--regular thinking, still have time left
				if p.XSpeed.finalGambitTimer == 0 then
					if p.XSsfx and p.XSpeed.countDownMusic and p.XSpeed.timeLeft > 12 then --got more time, stop the countdown
						S_StopSound(p.countdown)
						S_SetInternalMusicVolume(100, p)
						p.XSpeed.musicOn = true
						p.XSpeed.countDownMusic = false
					end
				
					if p.XSpeed.ticCount >= TICRATE then --one second has passed
						p.XSpeed.timeLeft = p.XSpeed.timeLeft - 1
						p.XSpeed.ticCount = 0
						
						if p.XSpeed.slowpokeTimer > 0 --players a few laps behind get a small amount of time to catch up and complete a lap...
							p.XSpeed.slowpokeTimer = p.XSpeed.slowpokeTimer + 1
							if p.XSpeed.slowpokeTimer > max((25 - 5 * mapheaderinfo[gamemap].numlaps), 5) and not (p.XSpeed.deathtimer > 0)
								XSdeadPlayers[#XSdeadPlayers+1] = {p, {{"Couldn't Keep Up", 0}, {"K_HSWALL", 0}}, 1, true} --...or they are knocked out of the race
							end
						end
					end
					
					--countdown stuff, player has 12 or less seconds left
					if p.XSsfx and p.XSpeed.timeLeft <= 12 and p.XSpeed.ticCount == 0 then --countdown starts
						if p.XSpeed.musicOn and not p.XSpeed.deathtimer then
							S_SetInternalMusicVolume(0, p)
							p.XSpeed.musicOn = false
						end
						
						if p.XSpeed.timeLeft == 12 then
							S_StartSound(p.countdown, sfx_cdn12, p)
							
						elseif p.XSpeed.timeJump then	--if time is added or removed, the music skips to match
							S_StopSound(p.countdown) --stop any existing countdown to ensure it ends at 0
							
							--S_StartSound(p.countdown, sfx_cdn0 + p.XSpeed.timeLeft, p) --would be nice if this worked
							if p.XSpeed.timeLeft == 11 then
								S_StartSound(p.countdown, sfx_cdn11, p)
							elseif p.XSpeed.timeLeft == 10 then
								S_StartSound(p.countdown, sfx_cdn10, p)
							elseif p.XSpeed.timeLeft == 9 then
								S_StartSound(p.countdown, sfx_cdn9, p)
							elseif p.XSpeed.timeLeft == 8 then
								S_StartSound(p.countdown, sfx_cdn8, p)
							elseif p.XSpeed.timeLeft == 7 then
								S_StartSound(p.countdown, sfx_cdn7, p)
							elseif p.XSpeed.timeLeft == 6 then
								S_StartSound(p.countdown, sfx_cdn6, p)
							elseif p.XSpeed.timeLeft == 5 then
								S_StartSound(p.countdown, sfx_cdn5, p)
							elseif p.XSpeed.timeLeft == 4 then
								S_StartSound(p.countdown, sfx_cdn4, p)
							elseif p.XSpeed.timeLeft == 3 then
								S_StartSound(p.countdown, sfx_cdn3, p)
							elseif p.XSpeed.timeLeft == 2 then
								S_StartSound(p.countdown, sfx_cdn2, p)
							elseif p.XSpeed.timeLeft == 1 then
								S_StartSound(p.countdown, sfx_cdn1, p)
							elseif p.XSpeed.timeLeft == 0 then
								S_StartSound(p.countdown, sfx_cdn0, p)
							end
						end
						p.XSpeed.countDownMusic = true;
					end
			
					--changefeed decay, messages are displayed for 3s if they aren't pushed out
					if p.XSpeed.changeFeed[0][0] ~= "" then
						if leveltime - p.XSpeed.changeFeed[0][1] > 3 * TICRATE then
							p.XSpeed.changeFeed[0][0] = ""
							p.XSpeed.changeFeed[0][1] = 0
						end
						if p.XSpeed.changeFeed[1][0] ~= "" then
							if leveltime - p.XSpeed.changeFeed[1][1] > 3 * TICRATE then
								p.XSpeed.changeFeed[1][0] = ""
								p.XSpeed.changeFeed[1][1] = 0
							end
							if p.XSpeed.changeFeed[2][0] ~= "" then
								if leveltime - p.XSpeed.changeFeed[2][1] > 3 * TICRATE then
									p.XSpeed.changeFeed[2][0] = ""
									p.XSpeed.changeFeed[2][1] = 0
								end
							end
						end
					end
					
					if p.XSpeed.timeJump and p.XSpeed.ticCount == 0 then
						p.XSpeed.timeJump = false
					end
					
					if p.XSpeed.timeLeft <= 0 then --out of time, blow them up
						p.kartstuff[k_invincibilitytimer] = 0
						p.kartstuff[k_growshrinktimer] = 0
						p.kartstuff[k_eggmanexplode] = 1	--final gambit is actually an eggbox
						for pindex = 0,15 do	--blame yourself
							if p == players[pindex] then
								p.kartstuff[k_eggmanblame] = pindex
								break
							end
						end
						
						p.XSpeed.timeLeft = 0
						p.XSpeed.ticCount = 0
						p.XSpeed.musicOn = false
						p.XSpeed.finalGambitTimer = 1 --start final gambit thinking next frame
						
					else	--still have time, increment tic counter
						p.XSpeed.ticCount = p.XSpeed.ticCount + 1
					end
					
					XSpeedSpecialInput(p, 1)
					
				--final gambit thinking, no time left
				elseif not p.XSpeed.deathtimer then
					p.XSpeed.finalGambitTimer = p.XSpeed.finalGambitTimer + 1
					if p.XSpeed.finalGambitTimer >= 3 * TICRATE / 2 then	--explosion takes about 1.5s
						if p.XSpeed.timeLeft > 0 then
							P_DamageMobj(p.mo, nil, nil, 10000) --respawn them because they got more time
							S_StartSound(nil, sfx_s3kac, p) --play revive sound
						else
							XSdeadPlayers[#XSdeadPlayers+1] = {p, {{"Out of Time", 0}, {"K_HSWALL", 0}}, 1, true} --kill them
						end
						S_SetInternalMusicVolume(100, p) --restore music
						p.XSpeed.finalGambitTimer = 0
						p.XSpeed.ticCount = 0
						p.XSpeed.killer = nil
					end
				end
			end
		end

		if p.pflags & PF_TIMEOVER then continue end
		
		--lap completion stuff
		if p.laps > p.XSpeed.lastlap then
			--distance estimation for final checkpoint
			p.XSpeed.trackLength = p.XSpeed.trackLength + P_AproxDistance(p.mo.x - p.XSpeed.lastCheckpointx, p.mo.y - p.XSpeed.lastCheckpointy) / FRACUNIT
			p.XSpeed.lastCheckpointx = p.mo.x
			p.XSpeed.lastCheckpointy = p.mo.y
			
			--reset vars
			p.XSpeed.lastCheckpoint = 0
			p.XSpeed.lastlap = p.laps
			p.XSpeed.nBoosts = 1
			p.XSpeed.nOrbis = 1
			p.XSpeed.slowpokeTimer = 0
			p.XSpeed.itemsUsedCount = 0
			
			XSmaxTrackLength = max($, p.XSpeed.trackLength) --always want the greatest length for fairness
			
			--stuff for inifinite looping tracks, not a to b tracks
			if not XSisSprintTrack
				--if p.kartstuff[k_position] == 1 --can't use this, in case of bad placement tracking
				if p.laps > XStopLap --leader completing a lap
					for pl in players.iterate 
						if pl.laps + 1 + mapheaderinfo[gamemap].numlaps/2 <= p.laps	--mark the slowpokes
							pl.XSpeed.slowpokeTimer = max($, 1)
						end
					end
				end
				if XStopLap < 25 --no actually infinite races please
					--time bonus for better placements
					addTime(p, ((10 - mapheaderinfo[gamemap].numlaps) / 2) *(countPlayersInGame() + 1 - p.kartstuff[k_position] - XSnDead) / (countPlayersInGame() - XSnDead))
				end
				--time added for estimated track length, floored at 5s, capped at 30s, decays each lap, no longer get this bonus once you complete 2x the normal track laps
				addTime(p, max(0, (max(10, min(30, ((100 * FRACUNIT / mapheaderinfo[gamemap].mobj_scale * XSmaxTrackLength / 100 / 100 ) ^2 / 28000 )))) * ((mapheaderinfo[gamemap].numlaps * 2) + 1 - p.laps) / (mapheaderinfo[gamemap].numlaps * 2)))
			end
			--recovery of time spent based on placement in race
			addTime(p, p.XSpeed.timespent *(countPlayersInGame() + 1 - p.kartstuff[k_position] - XSnDead) / (countPlayersInGame() - XSnDead))
			if p.XSpeed.timespent > 0
				p.XSpeed.percent = 100 * (countPlayersInGame() + 1 - p.kartstuff[k_position] - XSnDead) / (countPlayersInGame() - XSnDead)
			else
				p.XSpeed.percent = 0
			end
			
			XStopLap = max($, p.laps)
			p.XSpeed.lastLapTime = leveltime
			p.XSpeed.timespent = 0
			p.XSpeed.trackLength = 0
		end		
	end
	
	--modified hpmod code
	if #XSdeadPlayers then
		for i, k in ipairs(XSdeadPlayers) do
			local p = k[1]
			local source = k[2]
			if type(source) == "table" then
				--continue
			elseif source and source.valid then
				--nothing
			else
				k[2] = nil
			end
		end

		for i, k in ipairs(XSdeadPlayers) do
			--deal with each death here instead
			local p = k[1]
			local source = k[2]
			local damage = k[3]
			local force = k[4]
			if not (p.valid and p.XSpeed) then continue end
			
			--lololol no u
			if p.spectator then continue end
			
			if hitfeed then
				local v = generateHFForPlayer(p) --{{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p} --thanks hitfeed
				local s = {{}, {}}
				--print(k[2])
				--print(source)
				if type(source) == "table" then --they sent in a custom text
					--print("Sent in a custom HF string")
					s = source
				elseif source then --there is a source
					--print("Sent in a player")
					s = generateHFForPlayer(source)
				end

				HF_SendHitMessage(s, v, "K_HMEXPL") --HITFEED HAS A BUILD-IN EXPLODE ICON! v2 doesent (f) also thx snu
			else
				print(p.name .. " eliminated!")
			end
			p.XSpeed.deathtimer = 1
			killPlayer(p)
			--CONS_Printf(p, "Killing " + p.name)
			if p.mo and p.mo.valid then
				p.mo.momx = 0
				p.mo.momy = 0
				p.mo.momz = 0
			end
			S_StartSound(nil, sfx_hpelmn)
		end

		XSdeadPlayers = {}
	end

	do --check if everyone in-game is dead
		local aliveCount = 0
		local winner = nil
		local pInGame = 0
		for p in players.iterate do
			if not (p and p.valid) then continue end
			if p.spectator then continue end
			pInGame = $+1
			if p.pflags & PF_TIMEOVER then
				continue
			else
				aliveCount = $+1
				winner = p
				if aliveCount > 1 then break end
			end
		end
		
		if aliveCount == 0 and pInGame then
			XSeveryoneDeadTimer = 1
		elseif aliveCount == 1 and pInGame > 1 then --someone won by being last standing, exitlevel
			if not winner.XSpeed.nukedone then
				winner.XSpeed.nukedone = true
				P_NukeEnemies(winner.mo, winner.mo, RING_DIST*16) --helps prevent unwanted double kos
			end
			for p in players.iterate do
				if not (p and p.valid) then continue end
				if p.spectator then continue end
				if p == winner then
					if not winner.exiting then
					end
					P_DoPlayerExit(winner)
				else
					S_ChangeMusic("KRFAIL", true, nil)
				end
			end
		end
	end
end


local function XSpeedRespawn(p) --modified hpmod code
	if not p.XSpeed then
		resetXSpeed(p, mapheaderinfo[gamemap].numlaps)
	end
end

local function XSpeedDeath(pmo, mo, pmo2) --modified hpmod code
	if not XSpeed.running then return end

	if not (pmo and pmo.valid and pmo.player and pmo.player.valid) then return end
	if pmo.player.pflags&PF_TIMEOVER then return end

	if pmo.player.spectator then return end
	
	local attacker = nil
	if pmo2 and pmo2.valid and pmo2.player then
		attacker = pmo2.player
	end

	if mo and mo.valid and mo.type == MT_SINK then
		local boom = P_SpawnMobj(pmo.x, pmo.y, pmo.z, MT_FZEROBOOM)
		boom.scale = pmo.scale
		boom.angle = pmo.angle
		boom.target = pmo
		return
	end
	
	if pmo.player.kartstuff[k_eggmanexplode] then
		stealTime(pmo.player, attacker, 10)
	end
end

local SPINDMG = {
	[MT_ORBINAUT] = 10,
	[MT_ORBINAUT_SHIELD] = 5,
	[MT_JAWZ] = 10,
	[MT_JAWZ_DUD] = 5,
	[MT_JAWZ_SHIELD] = 5,
	[MT_BANANA] = 10,
	[MT_BANANA_SHIELD] = 5,
	[MT_BALLHOG] = 10,
	[MT_THUNDERSHIELD] = 5
}

local function XSpeedSpin(p, mo, pmo) --modified hpmod code
	if not XSpeed.running then return end
	if p.spectator
		return true
	end
	if not (p and p.valid) then return end
	if mo and mo.valid and SPINDMG[mo.type] then
		local plr = (pmo and pmo.valid) and pmo.player or nil
		stealTime(p, plr, SPINDMG[mo.type])
		--damageHp(p, SPINDMG[mo.type], plr)
	elseif mo and mo.valid and mo.player and mo.player.valid then
		if mo.player.kartstuff[k_invincibilitytimer] then
			if mo.player ~= p.XSpeed.killer then
				stealTime(p, mo.player, 10)
			end
		else
			local plr = (pmo and pmo.valid) and pmo.player or nil
			stealTime(p, plr, 5)
		end
	else
		--hazards don't steal time
	end
end

local function XSpeedExplode(p, mo, pmo) --modified hpmod code
	if not XSpeed.running then return end
	if not (p and p.valid) then return end
	local plr = (pmo and pmo.valid) and pmo.player or nil
	--final gambit
	if(plr ~= nil and plr.XSpeed.finalGambitTimer > 0 and plr.XSpeed.killer ~= p and (not p.exiting) and (not p.XSpeed.nukedone)) and (P_AproxDistance(p.mo.x - plr.mo.x, p.mo.y - plr.mo.y) / FRACUNIT) <= 400 --400 is a guess of the explode radius
		stealTime(p, plr, p.XSpeed.timeLeft)
		if p ~= plr then
			XSdeadPlayers[#XSdeadPlayers+1] = {p, {{"Final Gambit", 0}, {"K_HMEGG1", 0}}, 1, true}
		end
	--regular eggbox
	else
		stealTime(p, plr, 10)
	end
end

local function XSpeedSquish(p, mo, pmo) --modified hpmod code
	if not XSpeed.running then return end
	if not (p and p.valid) then return end
	local plr = (pmo and pmo.valid) and pmo.player or nil
	if not plr == nil
		stealTime(p, plr, 15)
	end
end

local function XSpeedBumpFight(mobj1, mobj2) --modified hpmod code
	if not XSpeed.running then return end
	
	if leveltime < starttime+TICRATE*3 then return end

	if not mobj2.valid then return end

	local p1, p2 = mobj1.player, mobj2.player
	
	if mobj2.player then
		if not (p1.kartstuff[k_growshrinktimer] == 0 and p2.kartstuff[k_growshrinktimer] == 0) then return end
		if not (shouldHurt(p1) and shouldHurt(p2)) then return end
		
		if p1.kartstuff[k_justbumped] ~= 0 or p2.kartstuff[k_justbumped] ~= 0 then --thanks wipezones
			return
		end
		
		if not ((mobj1.z >= mobj2.z and mobj1.z < mobj2.z + mobj2.height)
		or (mobj2.z >= mobj1.z and mobj2.z < mobj1.z + mobj1.height)) then
			return
		end
		
		local p1spd = getBumpSpeed(p1) --FixedMul(p1.speed, p1.kartweight*(FRACUNIT/16)+FRACUNIT)
		local p2spd = getBumpSpeed(p2) --FixedMul(p2.speed, p2.kartweight*(FRACUNIT/16)+FRACUNIT)
		local total = p1spd - p2spd
		
		local attacker, victim, dmg
			
		if total > 0 then
			attacker = p1
			victim = p2
			dmg = abs(FixedInt(total/10))
			
		elseif total < 0 then
			attacker = p2
			victim = p1
			dmg = abs(FixedInt(total/10))
			
		else
			--we tied???
			--ok then just return, no damage
			return
		end
		
		if attacker.XSpeed.lastBump + TICRATE > leveltime --boosts can cause double bumps so prevent double steal
			return
		end
		
		if attacker.kartstuff[k_sneakertimer] > 0
			stealTime(victim, attacker, 15)	--boost bumps are much more lethal
			K_PlayHitEmSound(attacker.mo)
			P_PlayRinglossSound(victim.mo)
		else
			stealTime(victim, attacker, 5)
		end
		
		attacker.XSpeed.lastBump = leveltime
		if dmg >= 10 and attacker.mo and attacker.mo.valid then
			if hitfeed and not attacker.kartstuff[k_sneakertimer] then
				HF_SendHitMessage(generateHFForPlayer(attacker), generateHFForPlayer(victim), "K_HMSHOE")
			end
			K_SpinPlayer(victim, attacker.mo, 1, attacker.mo, false)
		end
		
	end
	
end

addHook("ThinkFrame", XSpeedThink)
addHook("PlayerSpawn", XSpeedRespawn)
addHook("MobjDeath", XSpeedDeath, MT_PLAYER)
addHook("MobjCollide", XSpeedBumpFight, MT_PLAYER)
addHook("PlayerSpin", XSpeedSpin)
addHook("PlayerExplode", XSpeedExplode)
addHook("PlayerSquish", XSpeedSquish)

--Thinker for the low time warning indicator
local function XSpeedHpwarnThink(mo)	--modified hpmod code
	local dp = displayplayers[mo.displayplayern]
	local tp = players[mo.targetplayern]
	if mo.displayplayern <= splitscreen
	and dp and dp.valid and not dp.spectator
	and tp and tp.valid and not (dp == tp) and not tp.spectator
	and tp.XSpeed and tp.XSpeed.timeLeft <= 10
	and not (tp.pflags&PF_TIMEOVER) then
		mo.flags2 = $&~MF2_DONTDRAW
		P_TeleportMove(mo, tp.mo.x, tp.mo.y, tp.mo.z + FixedMul(48*FRACUNIT, tp.mo.scale))
		mo.momx = tp.mo.momx
		mo.momy = tp.mo.momy
		mo.momz = tp.mo.momz
		mo.scale = tp.mo.scale
		if tp.XSpeed.timeLeft <= 5 then
			mo.color = SKINCOLOR_CRIMSON
		else
			mo.color = SKINCOLOR_BLUE
		end
	else
		mo.flags2 = $|MF2_DONTDRAW
	end
end
addHook("MobjThinker", XSpeedHpwarnThink, MT_HPWARNING)

local function XSpeedHud(v, p) --modified hpmod code
	--calculate RETIRE string width
	if not XSretirelen then
		XSretirelen = 0
		for i = 1, XSretirestr:len() do
			local let = XSretirestr:sub(i, i)
			local patch = v.cachePatch(string.format("MKFNT%03d", let:byte()))
			XSretirelen = $+patch.width
		end
	end
	
	local vflags = V_HUDTRANS
	
	if not XSpeed.running then return end

	if not (p and p.valid) then return end
	if not p.XSpeed then return end
	if p.spectator then return end
	
	local vflags = V_HUDTRANS


	local booststring = ""
	local helpstring = ""
	local swapstring = ""
	
	if p.XStutorial.inputs == 0
		booststring = "   Up X2"
		helpstring = "Down X2"
		swapstring = "Up Down Up"
	elseif p.XStutorial.inputs == 1
		booststring = "custom 1"
		helpstring = "custom 3"
		swapstring = "custom 2"
	end
	
	if (not cv_tutorial.value) or p.XStutorial.slide == nil or p.XStutorial.slide == 9 then
		--nothing, but we want the best performance here
	elseif p.XStutorial.slide == 0 then
		v.drawString(100, 191, helpstring + " for help", vflags)
	elseif p.XStutorial.slide == 1 then
		v.drawString(85, 142, "Dont run out of time!", vflags)
		v.drawString(158, 152, "||", vflags)
		v.drawString(157, 162, "V", vflags)
		v.drawString(100, 191, helpstring + " for next", vflags)
	elseif p.XStutorial.slide == 2 then
		v.drawString(2, 135, "  Gain time each lap", vflags)
		v.drawString(2, 145, "No gain for sections", vflags)
		v.drawString(48, 155, "||", vflags)
		v.drawString(47, 165, "V", vflags)
		v.drawString(100, 191, helpstring + " for next", vflags)
	elseif p.XStutorial.slide == 3 then
		v.drawString(35, 55, "^", vflags)
		v.drawString(37, 62, "L", vflags)
		v.drawString(46, 65, "Hit foes w items and bumps", vflags)
		v.drawString(56, 75, "to steal time from them", vflags)
		v.drawString(100, 191, helpstring + " for next", vflags)
	elseif p.XStutorial.slide == 4 then
		v.drawString(146, 119, "Spend time to boost", vflags)
		v.drawString(146, 129, "Cost will increase", vflags)
		v.drawString(146, 139, "but resets each lap", vflags)
		v.drawString(214, 149, "||", vflags)
		v.drawString(213, 159, "V", vflags)
		v.drawString(100, 191, helpstring + " for next", vflags)
	elseif p.XStutorial.slide == 5 then
		v.drawString(160, 137, "Regain part of time", vflags)
		v.drawString(160, 147, "spent based on place", vflags)
		v.drawString(160, 157, "each lap/section >", vflags)
		v.drawString(100, 191, helpstring + " for next", vflags)
	elseif p.XStutorial.slide == 6 then
		v.drawString(78, 122, "Run out and you explode!", vflags)
		v.drawString(68, 132, "Hit a foe w your explosion", vflags)
		v.drawString(80, 142, "to steal ALL their time", vflags)
		v.drawString(158, 152, "||", vflags)
		v.drawString(157, 162, "V", vflags)
		v.drawString(100, 191, helpstring + " for next", vflags)
	elseif p.XStutorial.slide == 7 then
		v.drawString(94, 122, "KO a foe by stealing", vflags)
		v.drawString(94, 132, "their final seconds", vflags)
		v.drawString(96, 142, "to gain temp invinc", vflags)
		v.drawString(158, 152, "||", vflags)
		v.drawString(157, 162, "V", vflags)
		v.drawString(100, 191, helpstring + " for next", vflags)
	elseif p.XStutorial.slide == 8 then
		v.drawString(84, 122, "Console Ctrl Options", vflags)
		v.drawString(84, 132, "xspeed_inputs customs", vflags)
		v.drawString(84, 142, "xspeed_inputs double", vflags)
		v.drawString(100, 191, helpstring + " to hide", vflags)
	else
		p.XStutorial.slide = p.XStutorial.slide % 9
	end
	
	--draw time
	if p.XSpeed.timeLeft <= 10 then
		if p.XSpeed.timeLeft <= 0 then
			v.drawKartString(145, 174, "0:0", vflags)
		else
			v.drawKartString(145, 174, tostring(p.XSpeed.timeLeft - 1) + ":" + tostring(((TICRATE - p.XSpeed.ticCount) * 10/TICRATE) % 10), vflags)
		end
	elseif p.XSpeed.timeLeft >= 100 then
		v.drawKartString(143, 174, tostring(p.XSpeed.timeLeft), vflags)
	else
		v.drawKartString(149, 174, tostring(p.XSpeed.timeLeft), vflags)
	end
	
	--draw item use stuff
	if cv_XSmode.value == 0 or (cv_XSmode.value == 2 and p.XSpeed.itemSelect == 0)
		v.draw(195, 155, v.cachePatch("K_ITSHOE"), vflags)
	elseif cv_XSmode.value == 1 or (cv_XSmode.value == 2 and p.XSpeed.itemSelect == 1)
		v.draw(202, 167, v.cachePatch("XSORBI"), vflags)
	end
	
	if leveltime < starttime or 
		(leveltime < p.XSpeed.spawnTime + 5*TICRATE and p.XSpeed.nBoosts == 1 and p.XSpeed.nOrbis == 1) then
	
		if p.XSmodeChange	--mode change message
			if p.XSprevMode == "surv"
				v.drawKartString(112, 29, "SURVIVAL")
				v.drawString(89, 44, "LAST KART STANDING")
			elseif p.XSprevMode == "race"
				v.drawKartString(58, 29, "RACE TO THE FINISH")
				v.drawString(97, 44, "BOOST PAST RIVALS")
			end
		end
		
		--draw input info
		v.drawString(190, 172, booststring, vflags)
		v.drawString(190, 182, "to boost", vflags)
		if cv_XSmode.value == 2
			v.drawString(190, 147, swapstring, vflags)
			v.drawString(190, 157, "to swap", vflags)
		end
	
	--not available, draw X 
	elseif ((cv_XSmode.value == 0 or (cv_XSmode.value == 2 and p.XSpeed.itemSelect == 0)) and  p.XSpeed.timeLeft <= p.XSpeed.boostCost * p.XSpeed.nBoosts)
		or ((cv_XSmode.value == 1 or (cv_XSmode.value == 2 and p.XSpeed.itemSelect == 1)) and (p.XSpeed.timeLeft <= p.XSpeed.boostCost * p.XSpeed.nOrbis or leveltime < starttime + 10*TICRATE)) then
		v.drawKartString(211, 174, "X", vflags)
	
	--available, draw cost
	elseif (cv_XSmode.value == 0 or (cv_XSmode.value == 2 and p.XSpeed.itemSelect == 0)) and	10 > p.XSpeed.boostCost * p.XSpeed.nBoosts 
		v.drawKartString(211, 174, tostring(p.XSpeed.boostCost * p.XSpeed.nBoosts), vflags)
	elseif (cv_XSmode.value == 1 or (cv_XSmode.value == 2 and p.XSpeed.itemSelect == 1)) and 10 > p.XSpeed.boostCost * p.XSpeed.nOrbis
		v.drawKartString(211, 174, tostring(p.XSpeed.boostCost * p.XSpeed.nOrbis), vflags)
	elseif cv_XSmode.value == 0 or (cv_XSmode.value == 2 and p.XSpeed.itemSelect == 0)
		v.drawKartString(205, 174, tostring(p.XSpeed.boostCost * p.XSpeed.nBoosts), vflags)
	elseif cv_XSmode.value == 1 or (cv_XSmode.value == 2 and p.XSpeed.itemSelect == 1)
		v.drawKartString(205, 174, tostring(p.XSpeed.boostCost * p.XSpeed.nOrbis), vflags)
	end
	
	--draw change feed
	v.drawString(180, 172, p.XSpeed.changeFeed[0][0], vflags)
	v.drawString(180, 180, p.XSpeed.changeFeed[1][0], vflags)
	v.drawString(180, 188, p.XSpeed.changeFeed[2][0], vflags)
	
	if XSisSprintTrack --normal section counter: 1/3
		hud.enable("gametypeinfo")
	else	-- custom lap counter: LAP 1
		hud.disable("gametypeinfo")
		if p.laps+1 < 10
			v.drawKartString(29, 174, "LAP " + tostring(p.laps+1), vflags)
		else
			v.drawKartString(29, 174, "LAP" + tostring(p.laps+1), vflags)
		end
	end
	
	--players falling behind will see this
	if p.XSpeed.slowpokeTimer > 0
		v.drawKartString(110, 155, "HURRY UP", vflags)
	end
	
	--lap complete, draw percent recovered for placement
	if (p.XSpeed.lastLapTime + 2 * TICRATE) > leveltime and leveltime > starttime
		if p.XSpeed.percent == 0
			v.drawString(110, 157, "No time spent", vflags)
		else
			v.drawString(110, 157, tostring(p.XSpeed.percent) + "% recovered", vflags)
		end
	end
	
	if p.XSpeed.deathtimer then
		v.drawKartString(160-(XSretirelen/2), 100-6, XSretirestr, vflags)
	end
end
hud.add(XSpeedHud, "game")